local ffi = require('ffi')
local band, bor, lshift, rshift
do
  local _obj_0 = require('bit')
  band, bor, lshift, rshift = _obj_0.band, _obj_0.bor, _obj_0.lshift, _obj_0.rshift
end
local min, max
do
  local _obj_0 = math
  min, max = _obj_0.min, _obj_0.max
end
return function(nes)
  local mapper = require('Cart.Mapper')(nes)
  local cart = nes:getCart()
  local rom, chr = cart:getPRGROM(), cart:getCHRROM()
  local romSize = cart:getPRGROMSize()
  local chrSize = cart:getCHRROMSize()
  local prgBank = 0
  local chrBank = 0
  mapper.write = function(self, addr, val)
    if addr >= 0x8000 then
      prgBank = band(lshift(band(val, 0x03), 15), romSize - 1)
      chrBank = band(lshift(band(val, 0xf0), 9), chrSize - 1)
    end
  end
  mapper.read = function(self, addr)
    return rom[bor(band(addr, 0x7fff), prgBank)]
  end
  mapper.readCHR = function(self, addr)
    return chr[bor(band(addr, 0x1fff), chrBank)]
  end
  return mapper
end
