local ffi = require('ffi')
local band, bor, lshift, rshift
do
  local _obj_0 = require('bit')
  band, bor, lshift, rshift = _obj_0.band, _obj_0.bor, _obj_0.lshift, _obj_0.rshift
end
return function(nes)
  local mapper = require('Cart.Mapper')(nes)
  local cart = nes:getCart()
  local rom = cart:getPRGROM()
  local banks = {
    [0] = 0,
    [1] = cart:getPRGROMSize() - 0x4000
  }
  mapper.write = function(self, addr, val)
    if addr >= 0x8000 then
      banks[0] = lshift(band(val, 0x0f), 14)
    end
  end
  mapper.read = function(self, addr)
    local bank = banks[band(rshift(addr, 14), rshift(addr, 15))]
    return rom[bor(band(addr, 0x3fff), bank)]
  end
  return mapper
end
