local ffi = require('ffi')
local band, bor, lshift, rshift
do
  local _obj_0 = require('bit')
  band, bor, lshift, rshift = _obj_0.band, _obj_0.bor, _obj_0.lshift, _obj_0.rshift
end
return function(nes)
  local mapper = require('Cart.Mapper')(nes)
  local cart = nes:getCart()
  local chrBank = 0
  local maxBank = rshift(cart:getCHRROMSize(), 13) - 1
  local chr = cart:getCHRROM()
  mapper.write = function(self, addr, val)
    if not (addr >= 0x8000) then
      return 
    end
    chrBank = lshift(band(val, maxBank), 13)
  end
  mapper.readCHR = function(self, addr)
    return chr[bor(band(addr, 0x1fff), chrBank)]
  end
  return mapper
end
