local ffi = require('ffi')
local band, bor, lshift, rshift
do
  local _obj_0 = require('bit')
  band, bor, lshift, rshift = _obj_0.band, _obj_0.bor, _obj_0.lshift, _obj_0.rshift
end
local min, max
do
  local _obj_0 = math
  min, max = _obj_0.min, _obj_0.max
end
return function(nes)
  local mapper = require('Cart.Mapper')(nes)
  local cart = nes:getCart()
  local rom = cart:getPRGROM()
  local nametables = mapper.nametables
  nametables.switch1L()
  local prgBank = 0
  mapper.write = function(self, addr, val)
    if addr >= 0x8000 then
      prgBank = lshift(band(val, 0x07), 15)
      local ntBank = lshift(band(val, 0x10), 6)
      nametables.setPages(ntBank)
      return nametables.switch1L()
    end
  end
  mapper.read = function(self, addr)
    return rom[bor(band(addr, 0x7fff), prgBank)]
  end
  return mapper
end
