local ffi = require('ffi')
local band, rshift
do
  local _obj_0 = require('bit')
  band, rshift = _obj_0.band, _obj_0.rshift
end
local NTSelector
NTSelector = function(cart)
  local NTLO1, NTHI1 = 0x0000, 0x0400
  local NTLO2, NTHI2 = NTLO1, NTHI1
  local nt = ffi.new('int[8]', NTLO1, NTLO1, NTHI1, NTHI1, NTLO1, NTLO1, NTHI1, NTHI1)
  if band(cart:getNTMirroring(), 0x01) == 0x01 then
    nt[1], nt[2], nt[5], nt[6] = nt[3], nt[0], nt[3], nt[0]
  end
  return {
    selectNT = function(addr)
      return nt[rshift(addr, 10) - 8]
    end,
    setPages = function(lo1, hi1, lo2, hi2)
      if hi1 == nil then
        hi1 = lo1
      end
      if lo2 == nil then
        lo2 = lo1
      end
      if hi2 == nil then
        hi2 = hi1
      end
      NTLO1, NTHI1 = lo1, hi1
      NTLO2, NTHI2 = lo2, hi2
    end,
    switch1L = function()
      nt[0], nt[1], nt[2], nt[3] = NTLO1, NTLO1, NTLO1, NTLO1
      nt[4], nt[5], nt[6], nt[7] = NTLO1, NTLO1, NTLO1, NTLO1
    end,
    switch1H = function()
      nt[0], nt[1], nt[2], nt[3] = NTHI1, NTHI1, NTHI1, NTHI1
      nt[4], nt[5], nt[6], nt[7] = NTHI1, NTHI1, NTHI1, NTHI1
    end,
    switch2H = function()
      nt[0], nt[1], nt[2], nt[3] = NTLO1, NTLO1, NTHI1, NTHI1
      nt[4], nt[5], nt[6], nt[7] = NTLO1, NTLO1, NTHI1, NTHI1
    end,
    switch2V = function()
      nt[0], nt[1], nt[2], nt[3] = NTLO1, NTHI1, NTLO1, NTHI1
      nt[4], nt[5], nt[6], nt[7] = NTLO1, NTHI1, NTLO1, NTHI1
    end,
    switch4 = function()
      nt[0], nt[1], nt[2], nt[3] = NTLO1, NTLO2, NTHI1, NTHI2
      nt[4], nt[5], nt[6], nt[7] = NTLO1, NTLO2, NTHI1, NTHI2
    end
  }
end
return {
  NTSelector = NTSelector
}
