local INST = require('PPU.instructions')
local idle, vblank, enterVBL, clearSPRFlags, leaveVBL, frameStart, scanlineStart
idle, vblank, enterVBL, clearSPRFlags, leaveVBL, frameStart, scanlineStart = INST.idle, INST.vblank, INST.enterVBL, INST.clearSPRFlags, INST.leaveVBL, INST.frameStart, INST.scanlineStart
local skipOnOdd, setVBL, clearVBL
skipOnOdd, setVBL, clearVBL = INST.skipOnOdd, INST.setVBL, INST.clearVBL
local fetchNT, fetchDummyNT, fetchAT, fetchDummyAT
fetchNT, fetchDummyNT, fetchAT, fetchDummyAT = INST.fetchNT, INST.fetchDummyNT, INST.fetchAT, INST.fetchDummyAT
local fetchLoBG, fetchDummyLoBG, fetchHiBG, fetchDummyHiBG
fetchLoBG, fetchDummyLoBG, fetchHiBG, fetchDummyHiBG = INST.fetchLoBG, INST.fetchDummyLoBG, INST.fetchHiBG, INST.fetchDummyHiBG
local render, renderBG, incH, incV, syncH, syncV
render, renderBG, incH, incV, syncH, syncV = INST.render, INST.renderBG, INST.incH, INST.incV, INST.syncH, INST.syncV
local fetchLoSPR, fetchHiSPR, fetchSPRAT
fetchLoSPR, fetchHiSPR, fetchSPRAT = INST.fetchLoSPR, INST.fetchHiSPR, INST.fetchSPRAT
local evalSPR, clearOAM, resetOAMAddr, readOAM, writeOAM0, writeOAM
evalSPR, clearOAM, resetOAMAddr, readOAM, writeOAM0, writeOAM = INST.evalSPR, INST.clearOAM, INST.resetOAMAddr, INST.readOAM, INST.writeOAM0, INST.writeOAM
local dup
dup = function(self, first, last, frm, to)
  local range = (last - first) + 1
  for i = frm, to do
    self[i] = self[first + (i - frm) % range]
  end
end
local STATE_VIS0
do
  local oamr_render
  oamr_render = function(self, mem)
    readOAM(self, mem)
    return renderBG(self, mem)
  end
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = idle
    end
    ops = _tbl_0
  end
  ops[0] = function(self, mem)
    frameStart(self, mem)
    scanlineStart(self, mem)
    return renderBG(self, mem)
  end
  ops[1] = renderBG
  ops[2] = function(self, mem)
    clearOAM(self, mem)
    fetchNT(self, mem)
    return renderBG(self, mem)
  end
  ops[3] = renderBG
  ops[4] = function(self, mem)
    clearOAM(self, mem)
    fetchAT(self, mem)
    return renderBG(self, mem)
  end
  ops[5] = renderBG
  ops[6] = function(self, mem)
    clearOAM(self, mem)
    fetchLoBG(self, mem)
    return renderBG(self, mem)
  end
  ops[7] = renderBG
  ops[8] = function(self, mem)
    clearOAM(self, mem)
    fetchHiBG(self, mem)
    incH(self, mem)
    return renderBG(self, mem)
  end
  dup(ops, 1, 8, 9, 64)
  ops[65] = oamr_render
  ops[66] = function(self, mem)
    writeOAM0(self, mem)
    fetchNT(self, mem)
    return renderBG(self, mem)
  end
  ops[67] = oamr_render
  ops[68] = function(self, mem)
    writeOAM(self, mem)
    fetchAT(self, mem)
    return renderBG(self, mem)
  end
  ops[69] = oamr_render
  ops[70] = function(self, mem)
    writeOAM(self, mem)
    fetchLoBG(self, mem)
    return renderBG(self, mem)
  end
  ops[71] = oamr_render
  ops[72] = function(self, mem)
    writeOAM(self, mem)
    fetchHiBG(self, mem)
    incH(self, mem)
    return renderBG(self, mem)
  end
  ops[73] = oamr_render
  ops[74] = function(self, mem)
    writeOAM(self, mem)
    fetchNT(self, mem)
    return renderBG(self, mem)
  end
  ops[75] = oamr_render
  ops[76] = function(self, mem)
    writeOAM(self, mem)
    fetchAT(self, mem)
    return renderBG(self, mem)
  end
  ops[77] = oamr_render
  ops[78] = function(self, mem)
    writeOAM(self, mem)
    fetchLoBG(self, mem)
    return renderBG(self, mem)
  end
  ops[79] = oamr_render
  ops[80] = function(self, mem)
    writeOAM(self, mem)
    fetchHiBG(self, mem)
    incH(self, mem)
    return renderBG(self, mem)
  end
  dup(ops, 73, 80, 81, 248)
  ops[249] = oamr_render
  ops[250] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyNT(self, mem)
    return renderBG(self, mem)
  end
  ops[251] = oamr_render
  ops[252] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyAT(self, mem)
    return renderBG(self, mem)
  end
  ops[253] = oamr_render
  ops[254] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyLoBG(self, mem)
    return renderBG(self, mem)
  end
  ops[255] = oamr_render
  ops[256] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyHiBG(self, mem)
    return incV(self, mem)
  end
  ops[257] = function(self, mem)
    resetOAMAddr(self, mem)
    return syncH(self, mem)
  end
  ops[258] = fetchDummyNT
  ops[259] = idle
  ops[260] = function(self, mem)
    fetchSPRAT(self, mem)
    return fetchDummyAT(self, mem)
  end
  ops[261] = idle
  ops[262] = fetchLoSPR
  ops[263] = idle
  ops[264] = fetchHiSPR
  ops[265] = idle
  ops[266] = fetchDummyNT
  ops[267] = fetchSPRAT
  ops[268] = fetchDummyAT
  ops[269] = idle
  ops[270] = fetchLoSPR
  ops[271] = idle
  ops[272] = fetchHiSPR
  dup(ops, 265, 272, 273, 320)
  ops[321] = idle
  ops[322] = fetchNT
  ops[323] = idle
  ops[324] = fetchAT
  ops[325] = idle
  ops[326] = fetchLoBG
  ops[327] = idle
  ops[328] = function(self, mem)
    fetchHiBG(self, mem)
    return incH(self, mem)
  end
  dup(ops, 321, 328, 329, 336)
  ops[337] = idle
  ops[338] = fetchDummyNT
  ops[339] = idle
  ops[340] = fetchDummyNT
  STATE_VIS0 = ops
end
local STATE_VIS1
do
  local oamr_render
  oamr_render = function(self, mem)
    readOAM(self, mem)
    return render(self, mem)
  end
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = idle
    end
    ops = _tbl_0
  end
  ops[0] = function(self, mem)
    scanlineStart(self, mem)
    return render(self, mem)
  end
  ops[1] = render
  ops[2] = function(self, mem)
    clearOAM(self, mem)
    fetchNT(self, mem)
    return render(self, mem)
  end
  ops[3] = render
  ops[4] = function(self, mem)
    clearOAM(self, mem)
    fetchAT(self, mem)
    return render(self, mem)
  end
  ops[5] = render
  ops[6] = function(self, mem)
    clearOAM(self, mem)
    fetchLoBG(self, mem)
    return render(self, mem)
  end
  ops[7] = render
  ops[8] = function(self, mem)
    clearOAM(self, mem)
    fetchHiBG(self, mem)
    incH(self, mem)
    return render(self, mem)
  end
  dup(ops, 1, 8, 9, 64)
  ops[65] = oamr_render
  ops[66] = function(self, mem)
    writeOAM(self, mem)
    fetchNT(self, mem)
    return render(self, mem)
  end
  ops[67] = oamr_render
  ops[68] = function(self, mem)
    writeOAM(self, mem)
    fetchAT(self, mem)
    return render(self, mem)
  end
  ops[69] = oamr_render
  ops[70] = function(self, mem)
    writeOAM(self, mem)
    fetchLoBG(self, mem)
    return render(self, mem)
  end
  ops[71] = oamr_render
  ops[72] = function(self, mem)
    writeOAM(self, mem)
    fetchHiBG(self, mem)
    incH(self, mem)
    return render(self, mem)
  end
  dup(ops, 65, 72, 73, 248)
  ops[66] = function(self, mem)
    writeOAM0(self, mem)
    fetchNT(self, mem)
    return render(self, mem)
  end
  ops[249] = oamr_render
  ops[250] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyNT(self, mem)
    return render(self, mem)
  end
  ops[251] = oamr_render
  ops[252] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyAT(self, mem)
    return render(self, mem)
  end
  ops[253] = oamr_render
  ops[254] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyLoBG(self, mem)
    return render(self, mem)
  end
  ops[255] = oamr_render
  ops[256] = function(self, mem)
    writeOAM(self, mem)
    fetchDummyHiBG(self, mem)
    return incV(self, mem)
  end
  ops[257] = function(self, mem)
    resetOAMAddr(self, mem)
    return syncH(self, mem)
  end
  ops[258] = fetchDummyNT
  ops[259] = idle
  ops[260] = function(self, mem)
    fetchSPRAT(self, mem)
    return fetchDummyAT(self, mem)
  end
  ops[261] = idle
  ops[262] = fetchLoSPR
  ops[263] = idle
  ops[264] = fetchHiSPR
  ops[265] = idle
  ops[266] = fetchDummyNT
  ops[267] = fetchSPRAT
  ops[268] = fetchDummyAT
  ops[269] = idle
  ops[270] = fetchLoSPR
  ops[271] = idle
  ops[272] = fetchHiSPR
  dup(ops, 265, 272, 273, 320)
  ops[321] = idle
  ops[322] = fetchNT
  ops[323] = idle
  ops[324] = fetchAT
  ops[325] = idle
  ops[326] = fetchLoBG
  ops[327] = idle
  ops[328] = function(self, mem)
    fetchHiBG(self, mem)
    return incH(self, mem)
  end
  dup(ops, 321, 328, 329, 336)
  ops[337] = idle
  ops[338] = fetchDummyNT
  ops[339] = idle
  ops[340] = fetchDummyNT
  STATE_VIS1 = ops
end
local STATE_POST
do
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = idle
    end
    ops = _tbl_0
  end
  ops[340] = setVBL
  STATE_POST = ops
end
local STATE_VBL0
do
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = vblank
    end
    ops = _tbl_0
  end
  ops[0] = idle
  ops[1] = enterVBL
  STATE_VBL0 = ops
end
local STATE_VBL1
do
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = vblank
    end
    ops = _tbl_0
  end
  STATE_VBL1 = ops
end
local STATE_VBL2
do
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = vblank
    end
    ops = _tbl_0
  end
  ops[340] = function(self, mem)
    return clearVBL(self, mem)
  end
  STATE_VBL2 = ops
end
local STATE_PRE
do
  local ops
  do
    local _tbl_0 = { }
    for i = 0, 340 do
      _tbl_0[i] = idle
    end
    ops = _tbl_0
  end
  ops[0] = function(self, mem)
    scanlineStart(self, mem)
    return clearSPRFlags(self, mem)
  end
  ops[1] = idle
  ops[2] = fetchNT
  ops[3] = idle
  ops[4] = fetchAT
  ops[5] = idle
  ops[6] = fetchLoBG
  ops[7] = idle
  ops[8] = function(self, mem)
    fetchHiBG(self, mem)
    return incH(self, mem)
  end
  dup(ops, 1, 8, 9, 248)
  ops[249] = idle
  ops[250] = fetchDummyNT
  ops[251] = idle
  ops[252] = fetchDummyAT
  ops[253] = idle
  ops[254] = fetchDummyLoBG
  ops[255] = idle
  ops[256] = function(self, mem)
    fetchDummyHiBG(self, mem)
    return incV(self, mem)
  end
  ops[257] = function(self, mem)
    resetOAMAddr(self, mem)
    return syncH(self, mem)
  end
  ops[258] = fetchDummyNT
  ops[259] = fetchSPRAT
  ops[260] = fetchDummyAT
  ops[261] = idle
  ops[262] = fetchLoSPR
  ops[263] = idle
  ops[264] = fetchHiSPR
  ops[265] = idle
  dup(ops, 258, 264, 266, 272)
  dup(ops, 265, 271, 273, 279)
  ops[280] = function(self, mem)
    fetchHiSPR(self, mem)
    return syncV(self, mem)
  end
  ops[281] = syncV
  ops[282] = function(self, mem)
    syncV(self, mem)
    return fetchDummyNT(self, mem)
  end
  ops[283] = function(self, mem)
    syncV(self, mem)
    return fetchSPRAT(self, mem)
  end
  ops[284] = function(self, mem)
    syncV(self, mem)
    return fetchDummyAT(self, mem)
  end
  ops[285] = syncV
  ops[286] = function(self, mem)
    syncV(self, mem)
    return fetchLoSPR(self, mem)
  end
  ops[287] = syncV
  ops[288] = function(self, mem)
    syncV(self, mem)
    return fetchHiSPR(self, mem)
  end
  dup(ops, 281, 288, 289, 304)
  dup(ops, 265, 272, 305, 320)
  dup(ops, 1, 8, 321, 336)
  ops[1] = leaveVBL
  ops[337] = idle
  ops[338] = function(self, mem)
    skipOnOdd(self, mem)
    return fetchDummyNT(self, mem)
  end
  ops[339] = idle
  ops[340] = fetchDummyNT
  STATE_PRE = ops
end
local STATES = { }
STATES[0] = STATE_VIS0
for i = 1, 239 do
  STATES[i] = STATE_VIS1
end
STATES[240] = STATE_POST
STATES[241] = STATE_VBL0
for i = 242, 259 do
  STATES[i] = STATE_VBL1
end
STATES[260] = STATE_VBL2
STATES[261] = STATE_PRE
return STATES
